from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.xls.common import *
from spire.xls import *
from ctypes import *
import abc

class FontArrayWrapper (  XlsObject, IFont, IOptimizedUpdate) :
    """

    """
    @property
    def IsItalic(self)->bool:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_IsItalic.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_IsItalic.restype=c_bool
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_IsItalic, self.Ptr)
        return ret

    @IsItalic.setter
    def IsItalic(self, value:bool):
        GetDllLibXls().FontArrayWrapper_set_IsItalic.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_IsItalic, self.Ptr, value)

    @property

    def KnownColor(self)->'ExcelColors':
        """

        """
        GetDllLibXls().FontArrayWrapper_get_KnownColor.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_KnownColor.restype=c_int
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_KnownColor, self.Ptr)
        objwraped = ExcelColors(ret)
        return objwraped

    @KnownColor.setter
    def KnownColor(self, value:'ExcelColors'):
        GetDllLibXls().FontArrayWrapper_set_KnownColor.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_KnownColor, self.Ptr, value.value)

    @property

    def Color(self)->'Color':
        """

        """
        GetDllLibXls().FontArrayWrapper_get_Color.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_Color.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().FontArrayWrapper_get_Color, self.Ptr)
        ret = None if intPtr==None else Color(intPtr)
        return ret


    @Color.setter
    def Color(self, value:'Color'):
        GetDllLibXls().FontArrayWrapper_set_Color.argtypes=[c_void_p, c_void_p]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_Color, self.Ptr, value.Ptr)


    def SetThemeColor(self ,type:'ThemeColorType',tint:float):
        """

        """
        enumtype:c_int = type.value

        GetDllLibXls().FontArrayWrapper_SetThemeColor.argtypes=[c_void_p ,c_int,c_double]
        CallCFunction(GetDllLibXls().FontArrayWrapper_SetThemeColor, self.Ptr, enumtype,tint)

#
#    def GetThemeColor(self ,type:'ThemeColorType&',tint:'Double&')->bool:
#        """
#
#        """
#        intPtrtype:c_void_p = type.Ptr
#        intPtrtint:c_void_p = tint.Ptr
#
#        GetDllLibXls().FontArrayWrapper_GetThemeColor.argtypes=[c_void_p ,c_void_p,c_void_p]
#        GetDllLibXls().FontArrayWrapper_GetThemeColor.restype=c_bool
#        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_GetThemeColor, self.Ptr, intPtrtype,intPtrtint)
#        return ret


    @property
    def IsBold(self)->bool:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_IsBold.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_IsBold.restype=c_bool
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_IsBold, self.Ptr)
        return ret

    @IsBold.setter
    def IsBold(self, value:bool):
        GetDllLibXls().FontArrayWrapper_set_IsBold.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_IsBold, self.Ptr, value)

    @property
    def Size(self)->float:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_Size.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_Size.restype=c_double
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_Size, self.Ptr)
        return ret

    @Size.setter
    def Size(self, value:float):
        GetDllLibXls().FontArrayWrapper_set_Size.argtypes=[c_void_p, c_double]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_Size, self.Ptr, value)

    @property
    def IsStrikethrough(self)->bool:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_IsStrikethrough.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_IsStrikethrough.restype=c_bool
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_IsStrikethrough, self.Ptr)
        return ret

    @IsStrikethrough.setter
    def IsStrikethrough(self, value:bool):
        GetDllLibXls().FontArrayWrapper_set_IsStrikethrough.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_IsStrikethrough, self.Ptr, value)

    @property

    def StrikethroughType(self)->str:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_StrikethroughType.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_StrikethroughType.restype=c_void_p
        ret = PtrToStr(CallCFunction(GetDllLibXls().FontArrayWrapper_get_StrikethroughType, self.Ptr))
        return ret


    @StrikethroughType.setter
    def StrikethroughType(self, value:str):
        GetDllLibXls().FontArrayWrapper_set_StrikethroughType.argtypes=[c_void_p, c_wchar_p]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_StrikethroughType, self.Ptr, value)

    @property
    def IsSubscript(self)->bool:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_IsSubscript.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_IsSubscript.restype=c_bool
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_IsSubscript, self.Ptr)
        return ret

    @IsSubscript.setter
    def IsSubscript(self, value:bool):
        GetDllLibXls().FontArrayWrapper_set_IsSubscript.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_IsSubscript, self.Ptr, value)

    @property
    def IsSuperscript(self)->bool:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_IsSuperscript.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_IsSuperscript.restype=c_bool
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_IsSuperscript, self.Ptr)
        return ret

    @IsSuperscript.setter
    def IsSuperscript(self, value:bool):
        GetDllLibXls().FontArrayWrapper_set_IsSuperscript.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_IsSuperscript, self.Ptr, value)

    @property

    def Underline(self)->'FontUnderlineType':
        """

        """
        GetDllLibXls().FontArrayWrapper_get_Underline.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_Underline.restype=c_int
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_Underline, self.Ptr)
        objwraped = FontUnderlineType(ret)
        return objwraped

    @Underline.setter
    def Underline(self, value:'FontUnderlineType'):
        GetDllLibXls().FontArrayWrapper_set_Underline.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_Underline, self.Ptr, value.value)

    @property

    def FontName(self)->str:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_FontName.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_FontName.restype=c_void_p
        ret = PtrToStr(CallCFunction(GetDllLibXls().FontArrayWrapper_get_FontName, self.Ptr))
        return ret


    @FontName.setter
    def FontName(self, value:str):
        GetDllLibXls().FontArrayWrapper_set_FontName.argtypes=[c_void_p, c_wchar_p]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_FontName, self.Ptr, value)

    @property

    def VerticalAlignment(self)->'FontVertialAlignmentType':
        """

        """
        GetDllLibXls().FontArrayWrapper_get_VerticalAlignment.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_VerticalAlignment.restype=c_int
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_VerticalAlignment, self.Ptr)
        objwraped = FontVertialAlignmentType(ret)
        return objwraped

    @VerticalAlignment.setter
    def VerticalAlignment(self, value:'FontVertialAlignmentType'):
        GetDllLibXls().FontArrayWrapper_set_VerticalAlignment.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().FontArrayWrapper_set_VerticalAlignment, self.Ptr, value.value)


    def GenerateNativeFont(self)->'Font':
        """

        """
        GetDllLibXls().FontArrayWrapper_GenerateNativeFont.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_GenerateNativeFont.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().FontArrayWrapper_GenerateNativeFont, self.Ptr)
        ret = None if intPtr==None else Font(intPtr)
        return ret


    @property
    def IsAutoColor(self)->bool:
        """

        """
        GetDllLibXls().FontArrayWrapper_get_IsAutoColor.argtypes=[c_void_p]
        GetDllLibXls().FontArrayWrapper_get_IsAutoColor.restype=c_bool
        ret = CallCFunction(GetDllLibXls().FontArrayWrapper_get_IsAutoColor, self.Ptr)
        return ret

    def BeginUpdate(self):
        """

        """
        GetDllLibXls().FontArrayWrapper_BeginUpdate.argtypes=[c_void_p]
        CallCFunction(GetDllLibXls().FontArrayWrapper_BeginUpdate, self.Ptr)

    def EndUpdate(self):
        """

        """
        GetDllLibXls().FontArrayWrapper_EndUpdate.argtypes=[c_void_p]
        CallCFunction(GetDllLibXls().FontArrayWrapper_EndUpdate, self.Ptr)

