from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.xls.common import *
from spire.xls import *
from ctypes import *
import abc

class IconSet (SpireObject) :
    """
    <summary>
        Conditional formatting icon set condition.
    </summary>
    """
#    @property
#
#    def IconCriteria(self)->'IList1':
#        """
#    <summary>
#        Gets an IconCriteria collection
#    </summary>
#        """
#        GetDllLibXls().IconSet_get_IconCriteria.argtypes=[c_void_p]
#        GetDllLibXls().IconSet_get_IconCriteria.restype=c_void_p
#        intPtr = CallCFunction(GetDllLibXls().IconSet_get_IconCriteria, self.Ptr)
#        ret = None if intPtr==None else IList1(intPtr)
#        return ret
#


    @property

    def IconSetType(self)->'IconSetType':
        """
    <summary>
        Get or sets icon set type
    </summary>
        """
        GetDllLibXls().IconSet_get_IconSetType.argtypes=[c_void_p]
        GetDllLibXls().IconSet_get_IconSetType.restype=c_int
        ret = CallCFunction(GetDllLibXls().IconSet_get_IconSetType, self.Ptr)
        objwraped = IconSetType(ret)
        return objwraped

    @IconSetType.setter
    def IconSetType(self, value:'IconSetType'):
        GetDllLibXls().IconSet_set_IconSetType.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().IconSet_set_IconSetType, self.Ptr, value.value)

    @property
    def PercentileValues(self)->bool:
        """
    <summary>
        Gets or sets a Boolean value indicates whether thresholds for an icon
            set conditional format are determined using percentiles. 
    </summary>
        """
        GetDllLibXls().IconSet_get_PercentileValues.argtypes=[c_void_p]
        GetDllLibXls().IconSet_get_PercentileValues.restype=c_bool
        ret = CallCFunction(GetDllLibXls().IconSet_get_PercentileValues, self.Ptr)
        return ret

    @PercentileValues.setter
    def PercentileValues(self, value:bool):
        GetDllLibXls().IconSet_set_PercentileValues.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().IconSet_set_PercentileValues, self.Ptr, value)

    @property
    def IsReverseOrder(self)->bool:
        """
    <summary>
        Gets or sets a Boolean value indicates whether the order of icons is
            reversed for an icon set.
    </summary>
        """
        GetDllLibXls().IconSet_get_IsReverseOrder.argtypes=[c_void_p]
        GetDllLibXls().IconSet_get_IsReverseOrder.restype=c_bool
        ret = CallCFunction(GetDllLibXls().IconSet_get_IsReverseOrder, self.Ptr)
        return ret

    @IsReverseOrder.setter
    def IsReverseOrder(self, value:bool):
        GetDllLibXls().IconSet_set_IsReverseOrder.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().IconSet_set_IsReverseOrder, self.Ptr, value)

    @property
    def ShowIconOnly(self)->bool:
        """
    <summary>
        Gets or sets a Boolean value indcates whether only the icon is displayed
            for an icon set conditional format.
    </summary>
        """
        GetDllLibXls().IconSet_get_ShowIconOnly.argtypes=[c_void_p]
        GetDllLibXls().IconSet_get_ShowIconOnly.restype=c_bool
        ret = CallCFunction(GetDllLibXls().IconSet_get_ShowIconOnly, self.Ptr)
        return ret

    @ShowIconOnly.setter
    def ShowIconOnly(self, value:bool):
        GetDllLibXls().IconSet_set_ShowIconOnly.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().IconSet_set_ShowIconOnly, self.Ptr, value)

