from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.xls.common import *
from spire.xls import *
from ctypes import *
import abc

class Sparkline (  ISparkline) :
    """
    <summary>
        A sparkline represents a tiny chart or graphic in a worksheet cell that provides a visual representation of data. 
    </summary>
    """
    @property

    def DataRange(self)->'CellRange':
        """

        """
        GetDllLibXls().Sparkline_get_DataRange.argtypes=[c_void_p]
        GetDllLibXls().Sparkline_get_DataRange.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().Sparkline_get_DataRange, self.Ptr)
        ret = None if intPtr==None else CellRange(intPtr)
        return ret


    @DataRange.setter
    def DataRange(self, value:'CellRange'):
        GetDllLibXls().Sparkline_set_DataRange.argtypes=[c_void_p, c_void_p]
        CallCFunction(GetDllLibXls().Sparkline_set_DataRange, self.Ptr, value.Ptr)

    @property

    def RefRange(self)->'CellRange':
        """

        """
        GetDllLibXls().Sparkline_get_RefRange.argtypes=[c_void_p]
        GetDllLibXls().Sparkline_get_RefRange.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().Sparkline_get_RefRange, self.Ptr)
        ret = None if intPtr==None else CellRange(intPtr)
        return ret


    @RefRange.setter
    def RefRange(self, value:'CellRange'):
        GetDllLibXls().Sparkline_set_RefRange.argtypes=[c_void_p, c_void_p]
        CallCFunction(GetDllLibXls().Sparkline_set_RefRange, self.Ptr, value.Ptr)

    @property
    def Column(self)->int:
        """

        """
        GetDllLibXls().Sparkline_get_Column.argtypes=[c_void_p]
        GetDllLibXls().Sparkline_get_Column.restype=c_int
        ret = CallCFunction(GetDllLibXls().Sparkline_get_Column, self.Ptr)
        return ret

    @property
    def Row(self)->int:
        """

        """
        GetDllLibXls().Sparkline_get_Row.argtypes=[c_void_p]
        GetDllLibXls().Sparkline_get_Row.restype=c_int
        ret = CallCFunction(GetDllLibXls().Sparkline_get_Row, self.Ptr)
        return ret

