from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.xls.common import *
from spire.xls import *
from ctypes import *
import abc

class XlsPivotTable (  XlsObject, IPivotTable) :
    """

    """
    @property
    def ShowRowStripes(self)->bool:
        """
    <summary>
         Specifies a boolean value that indicates whether to show row stripe formatting for the
            table.
     </summary>
        """
        GetDllLibXls().XlsPivotTable_get_ShowRowStripes.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowRowStripes.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowRowStripes, self.Ptr)
        return ret

    @ShowRowStripes.setter
    def ShowRowStripes(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowRowStripes.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowRowStripes, self.Ptr, value)

    @property
    def ShowDataFieldInRow(self)->bool:
        """
    <summary>
        Represents the pivot table to add the Calculated 
            Data field in rows
    </summary>
        """
        GetDllLibXls().XlsPivotTable_get_ShowDataFieldInRow.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowDataFieldInRow.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowDataFieldInRow, self.Ptr)
        return ret

    @ShowDataFieldInRow.setter
    def ShowDataFieldInRow(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowDataFieldInRow.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowDataFieldInRow, self.Ptr, value)

    @property

    def ReportFilters(self)->'PivotReportFilters':
        """
    <summary>
        Gets or sets report filter collection
    </summary>
        """
        GetDllLibXls().XlsPivotTable_get_ReportFilters.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ReportFilters.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_ReportFilters, self.Ptr)
        ret = None if intPtr==None else PivotReportFilters(intPtr)
        return ret


    @ReportFilters.setter
    def ReportFilters(self, value:'PivotReportFilters'):
        GetDllLibXls().XlsPivotTable_set_ReportFilters.argtypes=[c_void_p, c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ReportFilters, self.Ptr, value.Ptr)

    @property
    def AllSubTotalTop(self)->bool:
        """
    <summary>
        Indicated whether diplay all subtotal at top of group,
            Change will cover every field's setting
    </summary>
        """
        GetDllLibXls().XlsPivotTable_get_AllSubTotalTop.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_AllSubTotalTop.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_AllSubTotalTop, self.Ptr)
        return ret

    @AllSubTotalTop.setter
    def AllSubTotalTop(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_AllSubTotalTop.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_AllSubTotalTop, self.Ptr, value)

    @property

    def CustomTableStyleName(self)->str:
        """
    <summary>
        Represent the custom Style for this PivotTable
    </summary>
        """
        GetDllLibXls().XlsPivotTable_get_CustomTableStyleName.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_CustomTableStyleName.restype=c_void_p
        ret = PtrToStr(CallCFunction(GetDllLibXls().XlsPivotTable_get_CustomTableStyleName, self.Ptr))
        return ret


    @CustomTableStyleName.setter
    def CustomTableStyleName(self, value:str):
        GetDllLibXls().XlsPivotTable_set_CustomTableStyleName.argtypes=[c_void_p, c_wchar_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_CustomTableStyleName, self.Ptr, value)

    def CalculateData(self):
        """

        """
        GetDllLibXls().XlsPivotTable_CalculateData.argtypes=[c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_CalculateData, self.Ptr)


    def ChangeDataSource(self ,dataSource:'IXLSRange'):
        """
    <summary>
        Change the data source of pivotTable.
    </summary>
    <param name="dataSource">New data source range.</param>
        """
        intPtrdataSource:c_void_p = dataSource.Ptr

        GetDllLibXls().XlsPivotTable_ChangeDataSource.argtypes=[c_void_p ,c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_ChangeDataSource, self.Ptr, intPtrdataSource)

    @dispatch

    def Clone(self ,parent:SpireObject)->SpireObject:
        """

        """
        intPtrparent:c_void_p = parent.Ptr

        GetDllLibXls().XlsPivotTable_Clone.argtypes=[c_void_p ,c_void_p]
        GetDllLibXls().XlsPivotTable_Clone.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_Clone, self.Ptr, intPtrparent)
        ret = None if intPtr==None else SpireObject(intPtr)
        return ret


#    @dispatch
#
#    def Clone(self ,parent:SpireObject,cacheIndex:int,hashWorksheetNames:'Dictionary2')->SpireObject:
#        """
#
#        """
#        intPtrparent:c_void_p = parent.Ptr
#        intPtrhashWorksheetNames:c_void_p = hashWorksheetNames.Ptr
#
#        GetDllLibXls().XlsPivotTable_ClonePCH.argtypes=[c_void_p ,c_void_p,c_int,c_void_p]
#        GetDllLibXls().XlsPivotTable_ClonePCH.restype=c_void_p
#        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_ClonePCH, self.Ptr, intPtrparent,cacheIndex,intPtrhashWorksheetNames)
#        ret = None if intPtr==None else SpireObject(intPtr)
#        return ret
#


    @property

    def Name(self)->str:
        """

        """
        GetDllLibXls().XlsPivotTable_get_Name.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_Name.restype=c_void_p
        ret = PtrToStr(CallCFunction(GetDllLibXls().XlsPivotTable_get_Name, self.Ptr))
        return ret


    @Name.setter
    def Name(self, value:str):
        GetDllLibXls().XlsPivotTable_set_Name.argtypes=[c_void_p, c_wchar_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_Name, self.Ptr, value)

    @property

    def PivotFields(self)->'PivotTableFields':
        """

        """
        GetDllLibXls().XlsPivotTable_get_PivotFields.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_PivotFields.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_PivotFields, self.Ptr)
        ret = None if intPtr==None else PivotTableFields(intPtr)
        return ret


    @property

    def DataFields(self)->'PivotDataFields':
        """

        """
        GetDllLibXls().XlsPivotTable_get_DataFields.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_DataFields.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_DataFields, self.Ptr)
        ret = None if intPtr==None else PivotDataFields(intPtr)
        return ret


    @property
    def IsRowGrand(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_IsRowGrand.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_IsRowGrand.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_IsRowGrand, self.Ptr)
        return ret

    @IsRowGrand.setter
    def IsRowGrand(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_IsRowGrand.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_IsRowGrand, self.Ptr, value)

    @property
    def IsColumnGrand(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_IsColumnGrand.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_IsColumnGrand.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_IsColumnGrand, self.Ptr)
        return ret

    @IsColumnGrand.setter
    def IsColumnGrand(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_IsColumnGrand.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_IsColumnGrand, self.Ptr, value)

    @property
    def ShowDrillIndicators(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_ShowDrillIndicators.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowDrillIndicators.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowDrillIndicators, self.Ptr)
        return ret

    @ShowDrillIndicators.setter
    def ShowDrillIndicators(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowDrillIndicators.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowDrillIndicators, self.Ptr, value)

    @property
    def DisplayFieldCaptions(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_DisplayFieldCaptions.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_DisplayFieldCaptions.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_DisplayFieldCaptions, self.Ptr)
        return ret

    @DisplayFieldCaptions.setter
    def DisplayFieldCaptions(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_DisplayFieldCaptions.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_DisplayFieldCaptions, self.Ptr, value)

    @property
    def RepeatItemsOnEachPrintedPage(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_RepeatItemsOnEachPrintedPage.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_RepeatItemsOnEachPrintedPage.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_RepeatItemsOnEachPrintedPage, self.Ptr)
        return ret

    @RepeatItemsOnEachPrintedPage.setter
    def RepeatItemsOnEachPrintedPage(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_RepeatItemsOnEachPrintedPage.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_RepeatItemsOnEachPrintedPage, self.Ptr, value)

    @property

    def BuiltInStyle(self)->PivotBuiltInStyles:
        """

        """
        GetDllLibXls().XlsPivotTable_get_BuiltInStyle.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_BuiltInStyle.restype=c_int
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_BuiltInStyle, self.Ptr)
        ret = None if intPtr==None else PivotBuiltInStyles(intPtr)
        return ret



    @BuiltInStyle.setter
    def BuiltInStyle(self, value:PivotBuiltInStyles):
        GetDllLibXls().XlsPivotTable_set_BuiltInStyle.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_BuiltInStyle, self.Ptr, value.value)


    @property
    def ShowRowGrand(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_ShowRowGrand.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowRowGrand.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowRowGrand, self.Ptr)
        return ret

    @ShowRowGrand.setter
    def ShowRowGrand(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowRowGrand.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowRowGrand, self.Ptr, value)

    @property
    def ShowColumnGrand(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_ShowColumnGrand.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowColumnGrand.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowColumnGrand, self.Ptr)
        return ret

    @ShowColumnGrand.setter
    def ShowColumnGrand(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowColumnGrand.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowColumnGrand, self.Ptr, value)

    @property
    def CacheIndex(self)->int:
        """

        """
        GetDllLibXls().XlsPivotTable_get_CacheIndex.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_CacheIndex.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_CacheIndex, self.Ptr)
        return ret

    @property

    def AutoFormatType(self)->'PivotAutoFomatTypes':
        """

        """
        GetDllLibXls().XlsPivotTable_get_AutoFormatType.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_AutoFormatType.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_AutoFormatType, self.Ptr)
        objwraped = PivotAutoFomatTypes(ret)
        return objwraped

    @AutoFormatType.setter
    def AutoFormatType(self, value:'PivotAutoFomatTypes'):
        GetDllLibXls().XlsPivotTable_set_AutoFormatType.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_AutoFormatType, self.Ptr, value.value)

    @property
    def IsCompatibleWithExcel2003(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_IsCompatibleWithExcel2003.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_IsCompatibleWithExcel2003.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_IsCompatibleWithExcel2003, self.Ptr)
        return ret

    @IsCompatibleWithExcel2003.setter
    def IsCompatibleWithExcel2003(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_IsCompatibleWithExcel2003.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_IsCompatibleWithExcel2003, self.Ptr, value)

    @property

    def Location(self)->'CellRange':
        """

        """
        GetDllLibXls().XlsPivotTable_get_Location.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_Location.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_Location, self.Ptr)
        ret = None if intPtr==None else CellRange(intPtr)
        return ret


    @Location.setter
    def Location(self, value:'CellRange'):
        GetDllLibXls().XlsPivotTable_set_Location.argtypes=[c_void_p, c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_Location, self.Ptr, value.Ptr)

    @property

    def Options(self)->'IPivotTableOptions':
        """

        """
        GetDllLibXls().XlsPivotTable_get_Options.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_Options.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_Options, self.Ptr)
        ret = None if intPtr==None else IPivotTableOptions(intPtr)
        return ret


    @property
    def RowsPerPage(self)->int:
        """

        """
        GetDllLibXls().XlsPivotTable_get_RowsPerPage.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_RowsPerPage.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_RowsPerPage, self.Ptr)
        return ret

    @RowsPerPage.setter
    def RowsPerPage(self, value:int):
        GetDllLibXls().XlsPivotTable_set_RowsPerPage.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_RowsPerPage, self.Ptr, value)

    @property
    def ColumnsPerPage(self)->int:
        """

        """
        GetDllLibXls().XlsPivotTable_get_ColumnsPerPage.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ColumnsPerPage.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ColumnsPerPage, self.Ptr)
        return ret

    @ColumnsPerPage.setter
    def ColumnsPerPage(self, value:int):
        GetDllLibXls().XlsPivotTable_set_ColumnsPerPage.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ColumnsPerPage, self.Ptr, value)

    @property

    def CalculatedFields(self)->'IPivotCalculatedFields':
        """

        """
        GetDllLibXls().XlsPivotTable_get_CalculatedFields.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_CalculatedFields.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_CalculatedFields, self.Ptr)
        ret = None if intPtr==None else PivotCalculatedFieldsCollection(intPtr)
        return ret


    @property

    def PageFields(self)->'IPivotFields':
        """

        """
        GetDllLibXls().XlsPivotTable_get_PageFields.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_PageFields.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_PageFields, self.Ptr)
        ret = None if intPtr==None else PivotTableFields(intPtr)
        return ret


    @property

    def RowFields(self)->'IPivotFields':
        """

        """
        GetDllLibXls().XlsPivotTable_get_RowFields.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_RowFields.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_RowFields, self.Ptr)
        ret = None if intPtr==None else PivotTableFields(intPtr)
        return ret


    @property

    def ColumnFields(self)->'IPivotFields':
        """

        """
        GetDllLibXls().XlsPivotTable_get_ColumnFields.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ColumnFields.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_ColumnFields, self.Ptr)
        ret = None if intPtr==None else PivotTableFields(intPtr)
        return ret


    @property
    def ShowSubtotals(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_ShowSubtotals.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowSubtotals.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowSubtotals, self.Ptr)
        return ret

    @ShowSubtotals.setter
    def ShowSubtotals(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowSubtotals.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowSubtotals, self.Ptr, value)

    def Clear(self):
        """

        """
        GetDllLibXls().XlsPivotTable_Clear.argtypes=[c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_Clear, self.Ptr)


    def ClearRowFieldFilter(self ,fieldName:str):
        """

        """
        
        GetDllLibXls().XlsPivotTable_ClearRowFieldFilter.argtypes=[c_void_p ,c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_ClearRowFieldFilter, self.Ptr, fieldName)


    def ClearColumnFieldFilter(self ,fieldName:str):
        """

        """
        
        GetDllLibXls().XlsPivotTable_ClearColumnFieldFilter.argtypes=[c_void_p ,c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_ClearColumnFieldFilter, self.Ptr, fieldName)


    def ClearFilter(self ,fieldName:str):
        """

        """
        
        GetDllLibXls().XlsPivotTable_ClearFilter.argtypes=[c_void_p ,c_void_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_ClearFilter, self.Ptr, fieldName)

    @property

    def Parent(self)->'XlsPivotTablesCollection':
        """

        """
        GetDllLibXls().XlsPivotTable_get_Parent.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_Parent.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_Parent, self.Ptr)
        ret = None if intPtr==None else XlsPivotTablesCollection(intPtr)
        return ret


    @property
    def DisplayErrorString(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_DisplayErrorString.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_DisplayErrorString.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_DisplayErrorString, self.Ptr)
        return ret

    @DisplayErrorString.setter
    def DisplayErrorString(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_DisplayErrorString.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_DisplayErrorString, self.Ptr, value)

    @property
    def DisplayNullString(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_DisplayNullString.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_DisplayNullString.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_DisplayNullString, self.Ptr)
        return ret

    @DisplayNullString.setter
    def DisplayNullString(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_DisplayNullString.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_DisplayNullString, self.Ptr, value)

    @property
    def EnableDrilldown(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_EnableDrilldown.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_EnableDrilldown.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_EnableDrilldown, self.Ptr)
        return ret

    @EnableDrilldown.setter
    def EnableDrilldown(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_EnableDrilldown.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_EnableDrilldown, self.Ptr, value)

    @property
    def EnableFieldDialog(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_EnableFieldDialog.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_EnableFieldDialog.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_EnableFieldDialog, self.Ptr)
        return ret

    @EnableFieldDialog.setter
    def EnableFieldDialog(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_EnableFieldDialog.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_EnableFieldDialog, self.Ptr, value)

    @property
    def EnableWizard(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_EnableWizard.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_EnableWizard.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_EnableWizard, self.Ptr)
        return ret

    @EnableWizard.setter
    def EnableWizard(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_EnableWizard.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_EnableWizard, self.Ptr, value)

    @property

    def ErrorString(self)->str:
        """

        """
        GetDllLibXls().XlsPivotTable_get_ErrorString.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ErrorString.restype=c_void_p
        ret = PtrToStr(CallCFunction(GetDllLibXls().XlsPivotTable_get_ErrorString, self.Ptr))
        return ret


    @ErrorString.setter
    def ErrorString(self, value:str):
        GetDllLibXls().XlsPivotTable_set_ErrorString.argtypes=[c_void_p, c_wchar_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ErrorString, self.Ptr, value)

    @property
    def ManualUpdate(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_ManualUpdate.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ManualUpdate.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ManualUpdate, self.Ptr)
        return ret

    @ManualUpdate.setter
    def ManualUpdate(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ManualUpdate.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ManualUpdate, self.Ptr, value)

    @property
    def MergeLabels(self)->bool:
        """

        """
        GetDllLibXls().XlsPivotTable_get_MergeLabels.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_MergeLabels.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_MergeLabels, self.Ptr)
        return ret

    @MergeLabels.setter
    def MergeLabels(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_MergeLabels.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_MergeLabels, self.Ptr, value)

    @property

    def NullString(self)->str:
        """

        """
        GetDllLibXls().XlsPivotTable_get_NullString.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_NullString.restype=c_void_p
        ret = PtrToStr(CallCFunction(GetDllLibXls().XlsPivotTable_get_NullString, self.Ptr))
        return ret


    @NullString.setter
    def NullString(self, value:str):
        GetDllLibXls().XlsPivotTable_set_NullString.argtypes=[c_void_p, c_wchar_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_NullString, self.Ptr, value)

    @property

    def PageFieldOrder(self)->'PagesOrderType':
        """

        """
        GetDllLibXls().XlsPivotTable_get_PageFieldOrder.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_PageFieldOrder.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_PageFieldOrder, self.Ptr)
        objwraped = PagesOrderType(ret)
        return objwraped

    @PageFieldOrder.setter
    def PageFieldOrder(self, value:'PagesOrderType'):
        GetDllLibXls().XlsPivotTable_set_PageFieldOrder.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_PageFieldOrder, self.Ptr, value.value)

    @property

    def PageFieldStyle(self)->str:
        """

        """
        GetDllLibXls().XlsPivotTable_get_PageFieldStyle.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_PageFieldStyle.restype=c_void_p
        ret = PtrToStr(CallCFunction(GetDllLibXls().XlsPivotTable_get_PageFieldStyle, self.Ptr))
        return ret


    @PageFieldStyle.setter
    def PageFieldStyle(self, value:str):
        GetDllLibXls().XlsPivotTable_set_PageFieldStyle.argtypes=[c_void_p, c_wchar_p]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_PageFieldStyle, self.Ptr, value)

    @property
    def PageFieldWrapCount(self)->int:
        """

        """
        GetDllLibXls().XlsPivotTable_get_PageFieldWrapCount.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_PageFieldWrapCount.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_PageFieldWrapCount, self.Ptr)
        return ret

    @PageFieldWrapCount.setter
    def PageFieldWrapCount(self, value:int):
        GetDllLibXls().XlsPivotTable_set_PageFieldWrapCount.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_PageFieldWrapCount, self.Ptr, value)

    @property

    def Cache(self)->'PivotCache':
        """

        """
        GetDllLibXls().XlsPivotTable_get_Cache.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_Cache.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_Cache, self.Ptr)
        ret = None if intPtr==None else PivotCache(intPtr)
        return ret


    @property

    def PivotConditionalFormats(self)->'PivotConditionalFormatCollection':
        """

        """
        GetDllLibXls().XlsPivotTable_get_PivotConditionalFormats.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_PivotConditionalFormats.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_PivotConditionalFormats, self.Ptr)
        ret = None if intPtr==None else PivotConditionalFormatCollection(intPtr)
        return ret


    @property

    def Workbook(self)->'XlsWorkbook':
        """

        """
        GetDllLibXls().XlsPivotTable_get_Workbook.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_Workbook.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_Workbook, self.Ptr)
        ret = None if intPtr==None else XlsWorkbook(intPtr)
        return ret


    @property

    def Worksheet(self)->'XlsWorksheet':
        """

        """
        GetDllLibXls().XlsPivotTable_get_Worksheet.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_Worksheet.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().XlsPivotTable_get_Worksheet, self.Ptr)
        ret = None if intPtr==None else XlsWorksheet(intPtr)
        return ret


    @property
    def FirstDataCol(self)->int:
        """
    <summary>
         Specifies the first column of the PivotTable data, relative to the top left cell in the ref
            value
     </summary>
        """
        GetDllLibXls().XlsPivotTable_get_FirstDataCol.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_FirstDataCol.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_FirstDataCol, self.Ptr)
        return ret

    @FirstDataCol.setter
    def FirstDataCol(self, value:int):
        GetDllLibXls().XlsPivotTable_set_FirstDataCol.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_FirstDataCol, self.Ptr, value)

    @property
    def FirstDataRow(self)->int:
        """
    <summary>
         Specifies the first column of the PivotTable data, relative to the top left cell in the ref
            value
     </summary>
        """
        GetDllLibXls().XlsPivotTable_get_FirstDataRow.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_FirstDataRow.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_FirstDataRow, self.Ptr)
        return ret

    @FirstDataRow.setter
    def FirstDataRow(self, value:int):
        GetDllLibXls().XlsPivotTable_set_FirstDataRow.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_FirstDataRow, self.Ptr, value)

    @property
    def FirstHeaderRow(self)->int:
        """
    <summary>
         Specifies the first row of the PivotTable header, relative to the top left cell in the ref
            value.
     </summary>
        """
        GetDllLibXls().XlsPivotTable_get_FirstHeaderRow.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_FirstHeaderRow.restype=c_int
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_FirstHeaderRow, self.Ptr)
        return ret

    @FirstHeaderRow.setter
    def FirstHeaderRow(self, value:int):
        GetDllLibXls().XlsPivotTable_set_FirstHeaderRow.argtypes=[c_void_p, c_int]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_FirstHeaderRow, self.Ptr, value)

    @property
    def ShowColHeaderStyle(self)->bool:
        """
    <summary>
        Specifies a boolean value that indicates whether to show column headers for the table.
    </summary>
        """
        GetDllLibXls().XlsPivotTable_get_ShowColHeaderStyle.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowColHeaderStyle.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowColHeaderStyle, self.Ptr)
        return ret

    @ShowColHeaderStyle.setter
    def ShowColHeaderStyle(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowColHeaderStyle.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowColHeaderStyle, self.Ptr, value)

    @property
    def ShowColStripes(self)->bool:
        """
    <summary>
         Specifies a boolean value that indicates whether to show column stripe formatting for
            the table.
     </summary>
        """
        GetDllLibXls().XlsPivotTable_get_ShowColStripes.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowColStripes.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowColStripes, self.Ptr)
        return ret

    @ShowColStripes.setter
    def ShowColStripes(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowColStripes.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowColStripes, self.Ptr, value)

    @property
    def ShowLastCol(self)->bool:
        """
    <summary>
        Specifies a boolean value that indicates whether to show the last column.
    </summary>
        """
        GetDllLibXls().XlsPivotTable_get_ShowLastCol.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowLastCol.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowLastCol, self.Ptr)
        return ret

    @ShowLastCol.setter
    def ShowLastCol(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowLastCol.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowLastCol, self.Ptr, value)

    @property
    def ShowRowHeaderStyle(self)->bool:
        """
    <summary>
        Specifies a boolean value that indicates whether to show row headers for the table.
    </summary>
        """
        GetDllLibXls().XlsPivotTable_get_ShowRowHeaderStyle.argtypes=[c_void_p]
        GetDllLibXls().XlsPivotTable_get_ShowRowHeaderStyle.restype=c_bool
        ret = CallCFunction(GetDllLibXls().XlsPivotTable_get_ShowRowHeaderStyle, self.Ptr)
        return ret

    @ShowRowHeaderStyle.setter
    def ShowRowHeaderStyle(self, value:bool):
        GetDllLibXls().XlsPivotTable_set_ShowRowHeaderStyle.argtypes=[c_void_p, c_bool]
        CallCFunction(GetDllLibXls().XlsPivotTable_set_ShowRowHeaderStyle, self.Ptr, value)

