import sys
from ctypes import *
from spire.xls.common import *
from spire.xls.common import dlllib
from spire.xls.common import dlllibXls

from spire.xls.common.Common import IntPtrArray
from spire.xls.common.Common import IntPtrWithTypeName
from spire.xls.common.Common import GetObjVectorFromArray
from spire.xls.common.Common import GetStrVectorFromArray
from spire.xls.common.Common import GetVectorFromArray
from spire.xls.common.Common import GetIntPtrArray
from spire.xls.common.Common import GetByteArray
from spire.xls.common.Common import GetIntValue
from spire.xls.common.Common import GetObjIntPtr
from spire.xls.common.Common import PtrToStr

from spire.xls.common.SpireObject import SpireObject
from spire.xls.common.CultureInfo import CultureInfo
from spire.xls.common.Boolean import Boolean
from spire.xls.common.Byte import Byte
from spire.xls.common.Char import Char
from spire.xls.common.Int16 import Int16
from spire.xls.common.Int32 import Int32
from spire.xls.common.Int64 import Int64
from spire.xls.common.PixelFormat import PixelFormat
from spire.xls.common.Size import Size
from spire.xls.common.SizeF import SizeF
from spire.xls.common.Point import Point
from spire.xls.common.PointF import PointF
from spire.xls.common.Rectangle import Rectangle
from spire.xls.common.RectangleF import RectangleF
from spire.xls.common.Single import Single
from spire.xls.common.TimeSpan import TimeSpan
from spire.xls.common.UInt16 import UInt16
from spire.xls.common.UInt32 import UInt32
from spire.xls.common.UInt64 import UInt64
from spire.xls.common.ImageFormat import ImageFormat
from spire.xls.common.Stream import Stream
from spire.xls.common.License import License
from spire.xls.common.Color import Color
from spire.xls.common.Image import Image
from spire.xls.common.Bitmap import Bitmap
from spire.xls.common.DateTime import DateTime
from spire.xls.common.Double import Double
from spire.xls.common.EmfType import EmfType
from spire.xls.common.Encoding import Encoding
from spire.xls.common.FontStyle import FontStyle
from spire.xls.common.Font import Font
from spire.xls.common.GraphicsUnit import GraphicsUnit
from spire.xls.common.ICollection import ICollection
from spire.xls.common.IDictionary import IDictionary
from spire.xls.common.IEnumerable import IEnumerable
from spire.xls.common.IEnumerator import IEnumerator
from spire.xls.common.IList import IList
from spire.xls.common.String import String



from spire.xls.AlertStyleType import AlertStyleType
from spire.xls.AutoFormatOptions import AutoFormatOptions
from spire.xls.AutoFormatType import AutoFormatType
from spire.xls.AverageType import AverageType
from spire.xls.AxisLineIdentifierType import AxisLineIdentifierType
from spire.xls.AxisTextDirectionType import AxisTextDirectionType
from spire.xls.AxisType import AxisType
from spire.xls.AxisTypes import AxisTypes
from spire.xls.BaseFormatType import BaseFormatType
from spire.xls.BordersLineType import BordersLineType
from spire.xls.BubbleSizeType import BubbleSizeType
from spire.xls.BuiltInPropertyType import BuiltInPropertyType
from spire.xls.BuiltInStyles import BuiltInStyles
from spire.xls.CategoryType import CategoryType
from spire.xls.CellDataType import CellDataType
from spire.xls.CellFormatType import CellFormatType
from spire.xls.ChartBackgroundMode import ChartBackgroundMode
from spire.xls.ChartBaseUnitType import ChartBaseUnitType
from spire.xls.ChartDisplayUnitType import ChartDisplayUnitType
from spire.xls.ChartLinePatternType import ChartLinePatternType
from spire.xls.ChartLineWeightType import ChartLineWeightType
from spire.xls.ChartMarkerType import ChartMarkerType
from spire.xls.ChartParagraphType import ChartParagraphType
from spire.xls.ChartPieType import ChartPieType
from spire.xls.ChartPlotEmptyType import ChartPlotEmptyType
from spire.xls.CheckState import CheckState
from spire.xls.ColorType import ColorType
from spire.xls.CommentHAlignType import CommentHAlignType
from spire.xls.CommentVAlignType import CommentVAlignType
from spire.xls.ComparisonOperatorType import ComparisonOperatorType
from spire.xls.CompoundLineType import CompoundLineType
from spire.xls.ConditionalFormatScope import ConditionalFormatScope
from spire.xls.ConditionalFormatType import ConditionalFormatType
from spire.xls.ConditionalTopNType import ConditionalTopNType
from spire.xls.ConditionValuePosition import ConditionValuePosition
from spire.xls.ConditionValueType import ConditionValueType
from spire.xls.ConnectionDataSourceType import ConnectionDataSourceType
from spire.xls.CopyRangeOptions import CopyRangeOptions
from spire.xls.DataBarAxisPosition import DataBarAxisPosition
from spire.xls.DataBarBorderType import DataBarBorderType
from spire.xls.DataBarFillType import DataBarFillType
from spire.xls.DataBarNegativeColorType import DataBarNegativeColorType
from spire.xls.DataLabelPositionType import DataLabelPositionType
from spire.xls.DataMarkerDirection import DataMarkerDirection
from spire.xls.DataSourceType import DataSourceType
from spire.xls.DateTimeGroupingType import DateTimeGroupingType
from spire.xls.DeleteOption import DeleteOption
from spire.xls.DropLineStyleType import DropLineStyleType
from spire.xls.DVAspect import DVAspect
from spire.xls.DynamicFilterType import DynamicFilterType
from spire.xls.ErrorBarIncludeType import ErrorBarIncludeType
from spire.xls.ErrorBarType import ErrorBarType
from spire.xls.Excel2016Charttype import Excel2016Charttype
from spire.xls.ExcelCalculationMode import ExcelCalculationMode
from spire.xls.ExcelChartType import ExcelChartType
from spire.xls.ExcelClearOptions import ExcelClearOptions
from spire.xls.ExcelColors import ExcelColors
from spire.xls.ExcelComboType import ExcelComboType
from spire.xls.ExcelFindOptions import ExcelFindOptions
from spire.xls.ExcelHorizontalAlignment import ExcelHorizontalAlignment
from spire.xls.ExcelPatternType import ExcelPatternType
from spire.xls.ExcelQuartileCalculation import ExcelQuartileCalculation
from spire.xls.ExcelSaveType import ExcelSaveType
from spire.xls.ExcelShapeType import ExcelShapeType
from spire.xls.ExcelSheetType import ExcelSheetType
from spire.xls.ExcelTotalsCalculation import ExcelTotalsCalculation
from spire.xls.ExcelTreeMapLabelOption import ExcelTreeMapLabelOption
from spire.xls.ExcelVersion import ExcelVersion
from spire.xls.ExcelVerticalAlignment import ExcelVerticalAlignment
from spire.xls.ExpandCollapseFlags import ExpandCollapseFlags
from spire.xls.FileFormat import FileFormat
from spire.xls.FillPictureType import FillPictureType
from spire.xls.FilterConditionType import FilterConditionType
from spire.xls.FilterDataType import FilterDataType
from spire.xls.FilterOperatorType import FilterOperatorType
from spire.xls.FilterType import FilterType
from spire.xls.FindType import FindType
from spire.xls.FontUnderlineType import FontUnderlineType
from spire.xls.FontVertialAlignmentType import FontVertialAlignmentType
from spire.xls.GeomertyAdjustValueFormulaType import GeomertyAdjustValueFormulaType
from spire.xls.GetText import GetText
from spire.xls.GradientColorType import GradientColorType
from spire.xls.GradientPatternType import GradientPatternType
from spire.xls.GradientPresetType import GradientPresetType
from spire.xls.GradientStyleType import GradientStyleType
from spire.xls.GradientTextureType import GradientTextureType
from spire.xls.GradientType import GradientType
from spire.xls.GradientVariantsType import GradientVariantsType
from spire.xls.GroupByType import GroupByType
from spire.xls.HorizontalAlignType import HorizontalAlignType
from spire.xls.HttpContentType import HttpContentType
from spire.xls.HyperLinkType import HyperLinkType
from spire.xls.IconSetType import IconSetType
from spire.xls.IgnoreErrorType import IgnoreErrorType
from spire.xls.ImageFormatType import ImageFormatType
from spire.xls.ImageLocationTypes import ImageLocationTypes
from spire.xls.ImageType import ImageType
from spire.xls.InsertMoveOption import InsertMoveOption
from spire.xls.InsertOptionsType import InsertOptionsType
from spire.xls.LegendPositionType import LegendPositionType
from spire.xls.LegendSpacingType import LegendSpacingType
from spire.xls.LineShapeType import LineShapeType
from spire.xls.LineStyleType import LineStyleType
from spire.xls.MeasureUnits import MeasureUnits
from spire.xls.MsoPathType import MsoPathType
from spire.xls.OdsPageBackgroundImagePositionType import OdsPageBackgroundImagePositionType
from spire.xls.OdsPageBackgroundImageType import OdsPageBackgroundImageType
from spire.xls.OdsPageBackgroundType import OdsPageBackgroundType
from spire.xls.OLEDBCommandType import OLEDBCommandType
from spire.xls.OleLinkType import OleLinkType
from spire.xls.OleObjectType import OleObjectType
from spire.xls.OrderBy import OrderBy
from spire.xls.OrderType import OrderType
from spire.xls.PageBreakExtentType import PageBreakExtentType
from spire.xls.PageBreakType import PageBreakType
from spire.xls.PageOrientationType import PageOrientationType
from spire.xls.PagesOrderType import PagesOrderType
from spire.xls.PaperSizeType import PaperSizeType
from spire.xls.PathFillMode import PathFillMode
from spire.xls.PivotAutoFomatTypes import PivotAutoFomatTypes
from spire.xls.PivotBuiltInStyles import PivotBuiltInStyles
from spire.xls.PivotDataType import PivotDataType
from spire.xls.PivotFieldFormatType import PivotFieldFormatType
from spire.xls.PivotFieldSortType import PivotFieldSortType
from spire.xls.PivotItemType import PivotItemType
from spire.xls.PivotPageAreaFieldsOrderType import PivotPageAreaFieldsOrderType
from spire.xls.PivotTableElement import PivotTableElement
from spire.xls.PivotTableLayoutType import PivotTableLayoutType
from spire.xls.PresetTextEffect import PresetTextEffect
from spire.xls.PrintCommentType import PrintCommentType
from spire.xls.PrintErrorsType import PrintErrorsType
from spire.xls.PrintingPageType import PrintingPageType
from spire.xls.PropertyType import PropertyType
from spire.xls.PrstGeomShapeType import PrstGeomShapeType
from spire.xls.ReadingOrderType import ReadingOrderType
from spire.xls.RectangleShapeType import RectangleShapeType
from spire.xls.RectangleStyleType import RectangleStyleType
from spire.xls.RelationShip import RelationShip
from spire.xls.RenameStrategy import RenameStrategy
from spire.xls.ResizeBehaveType import ResizeBehaveType
from spire.xls.RtfTags import RtfTags
from spire.xls.SelectionType import SelectionType
from spire.xls.ShapeArrowLengthType import ShapeArrowLengthType
from spire.xls.ShapeArrowStyleType import ShapeArrowStyleType
from spire.xls.ShapeArrowWidthType import ShapeArrowWidthType
from spire.xls.ShapeDashLineStyleType import ShapeDashLineStyleType
from spire.xls.ShapeFillType import ShapeFillType
from spire.xls.ShapeLayerChangeType import ShapeLayerChangeType
from spire.xls.ShapeLineStyleType import ShapeLineStyleType
from spire.xls.SheetProtectionType import SheetProtectionType
from spire.xls.SortComparsionType import SortComparsionType
from spire.xls.SortedWayType import SortedWayType
from spire.xls.SortOrientationType import SortOrientationType
from spire.xls.SparklineEmptyCells import SparklineEmptyCells
from spire.xls.SparklineType import SparklineType
from spire.xls.SpartlineVerticalAxisType import SpartlineVerticalAxisType
from spire.xls.SplitType import SplitType
from spire.xls.StrikeThroughStyle import StrikeThroughStyle
from spire.xls.StyleDefineType import StyleDefineType
from spire.xls.SubtotalTypes import SubtotalTypes
from spire.xls.TableBuiltInStyles import TableBuiltInStyles
from spire.xls.TextDirection import TextDirection
from spire.xls.TextDirectionType import TextDirectionType
from spire.xls.TextRotationType import TextRotationType
from spire.xls.ThemeColorType import ThemeColorType
from spire.xls.TickLabelPositionType import TickLabelPositionType
from spire.xls.TickMarkType import TickMarkType
from spire.xls.TimePeriodType import TimePeriodType
from spire.xls.TopBottomType import TopBottomType
from spire.xls.TopFormatType import TopFormatType
from spire.xls.TRangeValueType import TRangeValueType
from spire.xls.TrendLineType import TrendLineType
from spire.xls.UnderlineStyle import UnderlineStyle
from spire.xls.UnknownVariableAction import UnknownVariableAction
from spire.xls.ValidationComparisonOperator import ValidationComparisonOperator
from spire.xls.VariableTypeAction import VariableTypeAction
from spire.xls.VerticalAlignType import VerticalAlignType
from spire.xls.HTMLOptions import HTMLOptions
from spire.xls.ViewMode import ViewMode
from spire.xls.WorksheetCopyType import WorksheetCopyType
from spire.xls.AutoFitterOptions import AutoFitterOptions
from spire.xls.WorksheetVisibility import WorksheetVisibility
from spire.xls.XLSXBorderJoinType import XLSXBorderJoinType
from spire.xls.XLSXChartBevelType import XLSXChartBevelType
from spire.xls.XLSXChartLightingType import XLSXChartLightingType
from spire.xls.XLSXChartMaterialType import XLSXChartMaterialType
from spire.xls.XLSXChartPrespectiveType import XLSXChartPrespectiveType
from spire.xls.XLSXChartShadowInnerType import XLSXChartShadowInnerType
from spire.xls.XLSXChartShadowOuterType import XLSXChartShadowOuterType
from spire.xls.XLSXPivotItemType import XLSXPivotItemType
from spire.xls.XmlOpenType import XmlOpenType
from spire.xls.PdfConformanceLevel import PdfConformanceLevel
from spire.xls.CollectionBase import CollectionBase
from spire.xls.TextSaveOptions import TextSaveOptions
from spire.xls.IDocumentProperty import IDocumentProperty
from spire.xls.IPropertyData import IPropertyData
from spire.xls.ConverterSetting import ConverterSetting
from spire.xls.PageColRow import PageColRow
from spire.xls.ExternalConnection import ExternalConnection
from spire.xls.ExportTableOptions import ExportTableOptions
from spire.xls.DBConnection import DBConnection
from spire.xls.IExcelApplication import IExcelApplication
from spire.xls.XlsObject import XlsObject
from spire.xls.ImportObjectOptions import ImportObjectOptions
from spire.xls.QueryTableXls import QueryTableXls
from spire.xls.ReferRangeArea import ReferRangeArea
from spire.xls.ReferRangeArea import ListReferRangeAreas

from spire.xls.ICloneParent import ICloneParent
from spire.xls.WebQueryConnection import WebQueryConnection
from spire.xls.IShadow import IShadow
from spire.xls.IconSet import IconSet
from spire.xls.IConditionValue import IConditionValue
from spire.xls.IColorConditionValue import IColorConditionValue
from spire.xls.IColorScale import IColorScale
from spire.xls.XlsConditionValue import XlsConditionValue
from spire.xls.ConditionValue import ConditionValue
from spire.xls.ColorConditionValue import ColorConditionValue
from spire.xls.ColorScale import ColorScale
from spire.xls.NegativeBarFormat import NegativeBarFormat
from spire.xls.DataBarBorder import DataBarBorder
from spire.xls.DataBar import DataBar
from spire.xls.IConditionalFormat import IConditionalFormat
from spire.xls.IConditionalFormats import IConditionalFormats
from spire.xls.DocumentProperty import DocumentProperty
from spire.xls.IInterior import IInterior
from spire.xls.IPivotCache import IPivotCache
from spire.xls.IPivotField import IPivotField
from spire.xls.IPivotFields import IPivotFields
from spire.xls.IPivotTable import IPivotTable
from spire.xls.ISparkline import ISparkline
from spire.xls.ISparklines import ISparklines
from spire.xls.ISparklineGroup import ISparklineGroup
from spire.xls.Sparkline import Sparkline
from spire.xls.MarkerDesigner import MarkerDesigner
from spire.xls.XlsConditionalFormat import XlsConditionalFormat
from spire.xls.IShape import IShape
from spire.xls.ITextBox import ITextBox
from spire.xls.IPictureShape import IPictureShape
from spire.xls.IFormat3D import IFormat3D
from spire.xls.IBorder import IBorder
from spire.xls.IXLSRange import IXLSRange
from spire.xls.ITabSheet import ITabSheet
from spire.xls.CellStyleFlag import CellStyleFlag
from spire.xls.IExtendedFormat import IExtendedFormat
from spire.xls.IOptimizedUpdate import IOptimizedUpdate
from spire.xls.IAddInFunction import IAddInFunction
from spire.xls.IFont import IFont
from spire.xls.IGradient import IGradient
from spire.xls.IHPageBreak import IHPageBreak
from spire.xls.IHyperLink import IHyperLink
from spire.xls.IPageSetupBase import IPageSetupBase
from spire.xls.IRichTextString import IRichTextString
from spire.xls.RichTextObject import RichTextObject
from spire.xls.IDataValidation import IDataValidation
from spire.xls.IVPageBreak import IVPageBreak
from spire.xls.IStyle import IStyle
from spire.xls.IWorksheet import IWorksheet
from spire.xls.SaveShapeTypeOption import SaveShapeTypeOption
from spire.xls.OdsPageBackground import OdsPageBackground
from spire.xls.IGlow import IGlow
from spire.xls.IConditionalFormatsCollection import IConditionalFormatsCollection
from spire.xls.DataConnections import DataConnections
from spire.xls.ExternalLinkCollection import ExternalLinkCollection
from spire.xls.QueryTableCollection import QueryTableCollection
from spire.xls.IBuiltInDocumentProperties import IBuiltInDocumentProperties
from spire.xls.IXLSRanges import IXLSRanges
from spire.xls.IPivotCaches import IPivotCaches
from spire.xls.IPivotTables import IPivotTables
from spire.xls.IPictures import IPictures
from spire.xls.IChartShapes import IChartShapes
from spire.xls.IAddInFunctions import IAddInFunctions
from spire.xls.IBorders import IBorders
from spire.xls.XlsFontsCollection import XlsFontsCollection
from spire.xls.IHPageBreaks import IHPageBreaks
from spire.xls.IHyperLinks import IHyperLinks
from spire.xls.IVPageBreaks import IVPageBreaks
from spire.xls.ITabSheets import ITabSheets
from spire.xls.IWorksheets import IWorksheets
from spire.xls.IStyles import IStyles
from spire.xls.IAutoFilters import IAutoFilters
from spire.xls.IChartFillBorder import IChartFillBorder
from spire.xls.IChartBorder import IChartBorder
from spire.xls.IChartAxis import IChartAxis
from spire.xls.IChartTextArea import IChartTextArea
from spire.xls.IChartDataPoint import IChartDataPoint
from spire.xls.IChartDataTable import IChartDataTable
from spire.xls.IChartDropBar import IChartDropBar
from spire.xls.IChartFormat import IChartFormat
from spire.xls.IChartGridLine import IChartGridLine
from spire.xls.IChartInterior import IChartInterior
from spire.xls.IChartLegend import IChartLegend
from spire.xls.IChartLegendEntry import IChartLegendEntry
from spire.xls.IChartPageSetup import IChartPageSetup
from spire.xls.IChartFrameFormat import IChartFrameFormat
from spire.xls.IChartErrorBars import IChartErrorBars
from spire.xls.IChartSerie import IChartSerie
from spire.xls.IChartSerieDataFormat import IChartSerieDataFormat
from spire.xls.IChartSeriesAxis import IChartSeriesAxis
from spire.xls.IChartDataLabels import IChartDataLabels
from spire.xls.XlsChartTitleArea import XlsChartTitleArea
from spire.xls.IChartValueAxis import IChartValueAxis
from spire.xls.IChartWallOrFloor import IChartWallOrFloor
from spire.xls.IChartDataPoints import IChartDataPoints
from spire.xls.IChart import IChart
from spire.xls.ICharts import ICharts
from spire.xls.IChartSeries import IChartSeries
from spire.xls.IDataValidationCollection import IDataValidationCollection
from spire.xls.IDataValidationTable import IDataValidationTable
from spire.xls.XlsBuiltInDocumentProperties import XlsBuiltInDocumentProperties
from spire.xls.ICustomDocumentProperties import ICustomDocumentProperties
from spire.xls.IInternalWorksheet import IInternalWorksheet
from spire.xls.IMarkersDesigner import IMarkersDesigner
from spire.xls.IMigrantRange import IMigrantRange
from spire.xls.ICombinedRange import ICombinedRange
from spire.xls.IPivotCalculatedFields import IPivotCalculatedFields
from spire.xls.IPivotDataField import IPivotDataField
from spire.xls.IPivotDataFields import IPivotDataFields
from spire.xls.XlsPivotField import XlsPivotField
from spire.xls.PivotTableFields import PivotTableFields
from spire.xls.IPivotTableOptions import IPivotTableOptions
from spire.xls.XlsPivotCache import XlsPivotCache
from spire.xls.XlsPivotCacheField import XlsPivotCacheField
from spire.xls.XlsChartsCollection import XlsChartsCollection
from spire.xls.IPrstGeomShape import IPrstGeomShape
from spire.xls.IButtonShape import IButtonShape
from spire.xls.IButtonShapes import IButtonShapes
from spire.xls.INamedObject import INamedObject
from spire.xls.XlsPageSetupBase import XlsPageSetupBase
from spire.xls.CommonWrapper import CommonWrapper
from spire.xls.IChartShape import IChartShape
from spire.xls.IChartCategoryAxis import IChartCategoryAxis
from spire.xls.IChartLegendEntries import IChartLegendEntries
from spire.xls.ICheckBox import ICheckBox
from spire.xls.ICheckBoxes import ICheckBoxes
from spire.xls.IComboBoxShape import IComboBoxShape
from spire.xls.ITextBoxShape import ITextBoxShape
from spire.xls.IComment import IComment
from spire.xls.IGeomPathInfo import IGeomPathInfo
from spire.xls.IGeomPathShape import IGeomPathShape
from spire.xls.IGroupBox import IGroupBox
from spire.xls.ILabelShape import ILabelShape
from spire.xls.ILineShape import ILineShape
from spire.xls.IListBox import IListBox
from spire.xls.IOleObject import IOleObject
from spire.xls.IOvalShape import IOvalShape
from spire.xls.IArcShape import IArcShape
from spire.xls.IArcShapes import IArcShapes
from spire.xls.IGeomPath import IGeomPath
from spire.xls.IRadioButton import IRadioButton
from spire.xls.IRectangleShape import IRectangleShape
from spire.xls.IScrollBarShape import IScrollBarShape
from spire.xls.ICommentShape import ICommentShape
from spire.xls.IComments import IComments
from spire.xls.IShapeFill import IShapeFill
from spire.xls.IShapeLineFormat import IShapeLineFormat
from spire.xls.ISpinnerShape import ISpinnerShape
from spire.xls.IComboBoxes import IComboBoxes
from spire.xls.IGroupBoxes import IGroupBoxes
from spire.xls.ILabelShapes import ILabelShapes
from spire.xls.ILines import ILines
from spire.xls.IListBoxes import IListBoxes
from spire.xls.IOleObjects import IOleObjects
from spire.xls.IOvalShapes import IOvalShapes
from spire.xls.IPrstGeomShapes import IPrstGeomShapes
from spire.xls.IRadioButtons import IRadioButtons
from spire.xls.IRectangleShapes import IRectangleShapes
from spire.xls.IScrollBarShapes import IScrollBarShapes
from spire.xls.ISpinnerShapes import ISpinnerShapes
from spire.xls.ITextBoxLinkShape import ITextBoxLinkShape
from spire.xls.ITextBoxes import ITextBoxes
from spire.xls.TextBoxShapeBase import TextBoxShapeBase
from spire.xls.ITextFrame import ITextFrame
from spire.xls.IDataSort import IDataSort
from spire.xls.ISortColumn import ISortColumn
from spire.xls.ISortColumns import ISortColumns
from spire.xls.ISortedRule import ISortedRule
from spire.xls.IWorksheetGroup import IWorksheetGroup
from spire.xls.IReflectionEffect import IReflectionEffect
from spire.xls.IErrorIndicator import IErrorIndicator
from spire.xls.IDataBar import IDataBar
from spire.xls.IIconSet import IIconSet
from spire.xls.IAutoFilterCondition import IAutoFilterCondition
from spire.xls.INamedRange import INamedRange
from spire.xls.INumberFormat import INumberFormat
from spire.xls.IPageSetup import IPageSetup
from spire.xls.IExtendIndex import IExtendIndex
from spire.xls.IInternalAddtionalFormat import IInternalAddtionalFormat
from spire.xls.IInternalFont import IInternalFont
from spire.xls.IDigitalSignature import IDigitalSignature
from spire.xls.IDigitalSignatures import IDigitalSignatures
from spire.xls.PicTile import PicTile
from spire.xls.PicStretch import PicStretch
from spire.xls.ChartShadow import ChartShadow
from spire.xls.XlsShapeFill import XlsShapeFill
from spire.xls.XlsChartBorder import XlsChartBorder
from spire.xls.XlsChartAxis import XlsChartAxis
from spire.xls.XlsChartCategoryAxis import XlsChartCategoryAxis
from spire.xls.XlsChartDataTable import XlsChartDataTable
from spire.xls.XlsChartDropBar import XlsChartDropBar
from spire.xls.XlsChartFrameFormat import XlsChartFrameFormat
from spire.xls.XlsChartFormat import XlsChartFormat
from spire.xls.XlsChartFormatCollection import XlsChartFormatCollection
from spire.xls.XlsChartPlotArea import XlsChartPlotArea
from spire.xls.XlsChartInterior import XlsChartInterior
from spire.xls.XlsChartLegend import XlsChartLegend
from spire.xls.XlsChartLegendEntry import XlsChartLegendEntry
from spire.xls.XlsChartPageSetup import XlsChartPageSetup
from spire.xls.XlsChartSerieDataFormat import XlsChartSerieDataFormat
from spire.xls.XlsChartSeriesAxis import XlsChartSeriesAxis
from spire.xls.XlsChartDataLabelArea import XlsChartDataLabelArea
from spire.xls.XlsChartDataLabels import XlsChartDataLabels
from spire.xls.XlsChartDataPoint import XlsChartDataPoint
from spire.xls.XlsChartDataPointsCollection import XlsChartDataPointsCollection
from spire.xls.XlsChartValueAxis import XlsChartValueAxis
from spire.xls.XlsChartWallOrFloor import XlsChartWallOrFloor
from spire.xls.IChartTrendLine import IChartTrendLine
from spire.xls.IChartTrendLines import IChartTrendLines
from spire.xls.XlsShape import XlsShape
from spire.xls.XlsBitmapShape import XlsBitmapShape
from spire.xls.XlsPicturesCollection import XlsPicturesCollection
from spire.xls.RichText import RichText
from spire.xls.ExcelCommentObject import ExcelCommentObject
from spire.xls.ExcelComment import ExcelComment
from spire.xls.MsoPathInfo import MsoPathInfo
from spire.xls.XlsAddInFunction import XlsAddInFunction
from spire.xls.XlsAddInFunctionsCollection import XlsAddInFunctionsCollection
from spire.xls.ExternalLink import ExternalLink
from spire.xls.XlsWorkbookObjectsCollection import XlsWorkbookObjectsCollection
from spire.xls.ExcelFont import ExcelFont
from spire.xls.XlsBorder import XlsBorder
from spire.xls.XlsBorderArrayWrapper import XlsBorderArrayWrapper
from spire.xls.CellBorder import CellBorder
from spire.xls.BordersCollection import BordersCollection
from spire.xls.CellStyleObject import CellStyleObject
from spire.xls.XlsStylesCollection import XlsStylesCollection
from spire.xls.ExcelGradient import ExcelGradient
from spire.xls.ExcelInterior import ExcelInterior
from spire.xls.CellStyle import CellStyle
from spire.xls.XlsValidationWrapper import XlsValidationWrapper
from spire.xls.Validation import Validation
from spire.xls.ConditionalFormatWrapper import ConditionalFormatWrapper
from spire.xls.CondFormatCollectionWrapper import CondFormatCollectionWrapper
from spire.xls.ConditionalFormats import ConditionalFormats
from spire.xls.XlsRange import XlsRange
from spire.xls.XlsRange import EnumeratorXlsRange
from spire.xls.XlsRange import ListXlsRanges
from spire.xls.XlsHyperLink import XlsHyperLink
from spire.xls.XlsHyperLinksCollection import XlsHyperLinksCollection
from spire.xls.XlsPivotCachesCollection import XlsPivotCachesCollection

from spire.xls.XlsHPageBreak import XlsHPageBreak
from spire.xls.XlsVPageBreak import XlsVPageBreak
from spire.xls.HPageBreak import HPageBreak
from spire.xls.VPageBreak import VPageBreak
from spire.xls.XlsHPageBreaksCollection import XlsHPageBreaksCollection
from spire.xls.XlsVPageBreaksCollection import XlsVPageBreaksCollection
from spire.xls.IListObjectColumn import IListObjectColumn
from spire.xls.IListObjectColumn import ListObjectColumns
from spire.xls.IListObject import IListObject
from spire.xls.IListObjects import IListObjects
from spire.xls.XlsRangesCollection import XlsRangesCollection
from spire.xls.IWorkbook import IWorkbook
from spire.xls.OColor import OColor
from spire.xls.IAutoFilter import IAutoFilter
from spire.xls.XlsDocumentProperty import XlsDocumentProperty
from spire.xls.ShapeReflection import ShapeReflection
from spire.xls.Format3D import Format3D
from spire.xls.XlsChartSerie import XlsChartSerie
from spire.xls.XlsChartSeries import XlsChartSeries
from spire.xls.ShapeGlow import ShapeGlow
from spire.xls.WriteProtection import WriteProtection
from spire.xls.AddtionalFormatWrapper import AddtionalFormatWrapper
from spire.xls.XlsFill import XlsFill
from spire.xls.RichTextShape import RichTextShape
from spire.xls.RTFCommentArray import RTFCommentArray
from spire.xls.CellBaseStyle import CellBaseStyle
from spire.xls.FontArrayWrapper import FontArrayWrapper
from spire.xls.FontWrapper import FontWrapper
from spire.xls.GradientArrayWrapper import GradientArrayWrapper
from spire.xls.InteriorArrayWrapper import InteriorArrayWrapper
from spire.xls.RichTextString import RichTextString
from spire.xls.RangeRichTextString import RangeRichTextString
from spire.xls.RtfTextWriter import RtfTextWriter
from spire.xls.LOGFONT import LOGFONT
from spire.xls.RTFStringArray import RTFStringArray
from spire.xls.StyleArrayWrapper import StyleArrayWrapper
from spire.xls.UtilityMethods import UtilityMethods
from spire.xls.ExcelAddInFunction import ExcelAddInFunction
from spire.xls.XlsGradient import XlsGradient
from spire.xls.XlsValidation import XlsValidation
from spire.xls.XlsDataValidationTable import XlsDataValidationTable
from spire.xls.XlsFont import XlsFont
from spire.xls.XlsFontStyle import XlsFontStyle
from spire.xls.HyperLink import HyperLink
from spire.xls.XlsName import XlsName
from spire.xls.INameRanges import INameRanges
from spire.xls.ChartTextArea import ChartTextArea
from spire.xls.XlsEventArgs import XlsEventArgs
from spire.xls.XlsEventHandler import XlsEventHandler
from spire.xls.XlsPageSetup import XlsPageSetup
from spire.xls.PageSetup import PageSetup
from spire.xls.CellRange import ListCellRanges
from spire.xls.CellRange import CellRange
from spire.xls.SparklineCollection import SparklineCollection
from spire.xls.SparklineGroup import SparklineGroup
from spire.xls.SparklineGroupCollection import SparklineGroupCollection
from spire.xls.CellValueChangedEventArgs import CellValueChangedEventArgs
from spire.xls.XlsStyle import XlsStyle
from spire.xls.ListObjectCollection import ListObjectCollection
from spire.xls.LabelShapeCollection import LabelShapeCollection
from spire.xls.ConditionalFormat import ConditionalFormat
from spire.xls.Average import Average
from spire.xls.TopBottom import TopBottom
from spire.xls.ColorFilter import ColorFilter
from spire.xls.CustomFilter import CustomFilter
from spire.xls.CustomFilterCollection import CustomFilterCollection
from spire.xls.DateTimeGroupItem import DateTimeGroupItem
from spire.xls.DynamicFilter import DynamicFilter
from spire.xls.FilterColumn import FilterColumn
from spire.xls.XlsAutoFiltersCollection import XlsAutoFiltersCollection
from spire.xls.MultipleFilterCollection import MultipleFilterCollection
from spire.xls.Top10Filter import Top10Filter
from spire.xls.SortColumn import SortColumn
from spire.xls.SortColumns import SortColumns
from spire.xls.DataSorter import DataSorter
from spire.xls.EncryptedKeyInfo import EncryptedKeyInfo
from spire.xls.PivotCalculatedFieldsCollection import PivotCalculatedFieldsCollection
from spire.xls.PivotConditionalFormatCollection import PivotConditionalFormatCollection
from spire.xls.AutoSortScope import AutoSortScope
from spire.xls.PivotConditionalFormat import PivotConditionalFormat
from spire.xls.PivotDataField import PivotDataField
from spire.xls.PivotDataFields import PivotDataFields
from spire.xls.PivotItem import PivotItem
from spire.xls.PivotReportFilter import PivotReportFilter
from spire.xls.PivotReportFilters import PivotReportFilters
from spire.xls.PivotStyle import PivotStyle
from spire.xls.PivotTableStyle import PivotTableStyle
from spire.xls.PivotCache import PivotCache
from spire.xls.PivotField import PivotField
from spire.xls.XlsPivotTable import XlsPivotTable
from spire.xls.XlsPivotTablesCollection import XlsPivotTablesCollection
from spire.xls.PivotTable import PivotTable
from spire.xls.ChartLegendEntriesColl import ChartLegendEntriesColl
from spire.xls.ChartBorder import ChartBorder
from spire.xls.XlsChartGridLine import XlsChartGridLine
from spire.xls.ChartCategoryAxis import ChartCategoryAxis
from spire.xls.ChartDataLabels import ChartDataLabels
from spire.xls.ChartSerieDataFormat import ChartSerieDataFormat
from spire.xls.ChartDataPoint import ChartDataPoint
from spire.xls.ChartDataTable import ChartDataTable
from spire.xls.ChartDropBar import ChartDropBar
from spire.xls.ChartFormat import ChartFormat
from spire.xls.ChartArea import ChartArea
from spire.xls.ChartGridLine import ChartGridLine
from spire.xls.ChartInterior import ChartInterior
from spire.xls.ChartLegend import ChartLegend
from spire.xls.XlsChartLegendArea import XlsChartLegendArea
from spire.xls.ChartLegendEntry import ChartLegendEntry
from spire.xls.ChartPageSetup import ChartPageSetup
from spire.xls.ChartPlotArea import ChartPlotArea
from spire.xls.ChartDataPointsCollection import ChartDataPointsCollection
from spire.xls.ChartSerie import ChartSerie
from spire.xls.HistogramAxisFormat import HistogramAxisFormat
from spire.xls.ChartSeriesAxis import ChartSeriesAxis
from spire.xls.ChartTitle import ChartTitle
from spire.xls.ChartValueAxis import ChartValueAxis
from spire.xls.ChartWallOrFloor import ChartWallOrFloor
from spire.xls.ChartFormatCollection import ChartFormatCollection
from spire.xls.ChartSeries import ChartSeries
from spire.xls.GeomertyAdjustValue import GeomertyAdjustValue
from spire.xls.XlsGradientStop import XlsGradientStop
from spire.xls.GradientStops import GradientStops
from spire.xls.CommentsRange import CommentsRange
from spire.xls.GeomertyAdjustValuesCollection import GeomertyAdjustValuesCollection
from spire.xls.XlsPrstGeomShape import XlsPrstGeomShape
from spire.xls.ExcelPicture import ExcelPicture
from spire.xls.XlsButtonShape import XlsButtonShape
from spire.xls.XlsCheckBoxShape import XlsCheckBoxShape
from spire.xls.XlsComboBoxShape import XlsComboBoxShape
from spire.xls.XlsComment import XlsComment
from spire.xls.XlsGroupBoxShape import XlsGroupBoxShape
from spire.xls.XlsLabelShape import XlsLabelShape
from spire.xls.XlsLineShape import XlsLineShape
from spire.xls.XlsListBoxShape import XlsListBoxShape
from spire.xls.XlsOvalShape import XlsOvalShape
from spire.xls.XlsArcShape import XlsArcShape
from spire.xls.ShapeGeomPath import ShapeGeomPath
from spire.xls.ShapeSegmentPath import ShapeSegmentPath
from spire.xls.XlsRadioButtonShape import XlsRadioButtonShape
from spire.xls.XlsRectangleShape import XlsRectangleShape
from spire.xls.XlsScrollBarShape import XlsScrollBarShape
from spire.xls.XlsShapeLineFormat import XlsShapeLineFormat
from spire.xls.XlsSpinnerShape import XlsSpinnerShape
from spire.xls.XlsTextBoxShape import XlsTextBoxShape
from spire.xls.IShapes import IShapes
from spire.xls.XlsChartFill import XlsChartFill
from spire.xls.BuiltInDocumentProperties import BuiltInDocumentProperties
from spire.xls.ShapeCollectionBase import ShapeCollectionBase
from spire.xls.XlsCommentsCollection import XlsCommentsCollection
from spire.xls.RangesCollection import RangesCollection
from spire.xls.PivotCachesCollection import PivotCachesCollection
from spire.xls.PivotTablesCollection import PivotTablesCollection
from spire.xls.ArcShapeCollection import ArcShapeCollection
from spire.xls.ButtonShapeCollection import ButtonShapeCollection
from spire.xls.CheckBoxCollection import CheckBoxCollection
from spire.xls.ComboBoxCollection import ComboBoxCollection
from spire.xls.GroupBoxCollection import GroupBoxCollection
from spire.xls.LineCollection import LineCollection
from spire.xls.ListBoxCollection import ListBoxCollection
from spire.xls.OvalShapeCollection import OvalShapeCollection
from spire.xls.PrstGeomShapeCollection import PrstGeomShapeCollection
from spire.xls.RadioButtonCollection import RadioButtonCollection
from spire.xls.RectangleCollection import RectangleCollection
from spire.xls.ScrollBarCollection import ScrollBarCollection
from spire.xls.XlsHeaderFooterShapeCollection import XlsHeaderFooterShapeCollection
from spire.xls.SpinnerShapeCollection import SpinnerShapeCollection
from spire.xls.TextBoxCollection import TextBoxCollection
from spire.xls.CommentsCollection import CommentsCollection
from spire.xls.PicturesCollection import PicturesCollection
from spire.xls.BordersCollectionArrayWrapper import BordersCollectionArrayWrapper
from spire.xls.AddInFunctionsCollection import AddInFunctionsCollection
from spire.xls.XlsBordersCollection import XlsBordersCollection
from spire.xls.XlsDataValidationCollection import XlsDataValidationCollection
from spire.xls.FontsCollection import FontsCollection
from spire.xls.HPageBreaksCollection import HPageBreaksCollection
from spire.xls.HyperLinksCollection import HyperLinksCollection
from spire.xls.StylesCollection import StylesCollection
from spire.xls.VPageBreaksCollection import VPageBreaksCollection
from spire.xls.CollectionExtended import CollectionExtended
from spire.xls.CollectionChangeEventArgs import CollectionChangeEventArgs
from spire.xls.AutoFiltersCollection import AutoFiltersCollection
from spire.xls.XlsConditionalFormats import XlsConditionalFormats
from spire.xls.XlsWorksheetConditionalFormats import XlsWorksheetConditionalFormats
from spire.xls.WorksheetConditionalFormats import WorksheetConditionalFormats
from spire.xls.PaperSizeEntry import PaperSizeEntry
from spire.xls.CellValueChangedEventHandler import CellValueChangedEventHandler
from spire.xls.XlsChartShape import XlsChartShape
from spire.xls.Chart import Chart
from spire.xls.XlsWorksheetChartsCollection import XlsWorksheetChartsCollection
from spire.xls.WorksheetChartsCollection import WorksheetChartsCollection
from spire.xls.XlsWorksheetBase import XlsWorksheetBase
from spire.xls.XlsChart import XlsChart
from spire.xls.ChartSheet import ChartSheet
from spire.xls.ChartsCollection import ChartsCollection
from spire.xls.XlsWorksheet import XlsWorksheet
from spire.xls.XlsWorksheetsCollection import XlsWorksheetsCollection

#class Workbook (SpireObject) :
#    pass

from spire.xls.Worksheet import Worksheet
from spire.xls.XlsWorkbook import XlsWorkbook
from spire.xls.WorkbookObjectsCollection import WorkbookObjectsCollection
from spire.xls.WorksheetsCollection import WorksheetsCollection
from spire.xls.Workbook import Workbook
from spire.xls.StringUtil import StringUtil


